ChiliProject - Bug # 432: Adding yourself as an issue watcher doesn't update the Watch icons

Status: Ready for review Priority: Normal
Author: Eric Davis Category: Issue tracking
Created: 2011-05-27 Assignee:

Updated: 2011-05-30 Due date:

Remote issue URL:

Affected version: unstable

Description: # View issue you are not watching

# Add yourself as a watcher using the sidebar form (not the "Watch" icons)
# You are added as a watcher but the "Watch" icons aren't updated

| would expect that the icons are updated along with the sidebar form. #416 added some code that might
make this easier.

History

2011-05-27 06:35 pm - Holger Just

This is basically the other way round from #311.
2011-05-27 09:23 pm - Eric Davis

Holger Just wrote:

> This is basically the other way round from #311.

Exactly.

2011-05-28 03:09 pm - Felix Schafer
- Assignee set to Felix Schéfer

x_X So @WatchersController#destroy@ (Click on the bin next to a watcher's name) takes @"user_id" => "5"@ as a parameter, whereas
@WatchersController#new@ takes @"watcher"=>{"user_id"=>"5"}@. I'd like to unify that to just @"user_id" => "5"@, any problems with that?
2011-05-28 03:55 pm - Holger Just

Felix SchArfer wrote:

> I'd like to unify that to just @"user_id" => "5"@, any problems with that?

If you do that, we can't mass-create watchers anymore. Although we don't do that currently (apart from issue update), we really should, using some kind

of auto-completer like the member add Ul in the admin section (just less broken).

2011-05-28 03:59 pm - Holger Just
Just re-read it again and noticed that I'm an idiot. So disregard my comment and move along. Nothing to see here...

2011-05-28 04:54 pm - Felix Schéfer
- Target version set to 2.0.0

- Assignee deleted (Felix Schéfer)

- Status changed from Open to Ready for review

The branch is here https://github.com/thegcat/chiliproject/tree/bug/432-update_watch_icons_when_adding_a_watcher_from_the_sidebar , there's no

pull request yet as | think the option passing for @render_watcher_dropdown@ could be improved, and the list of "css tags" passed to all these
@:replace@ options should probably be set once in the Issue show view and passed to every part needing it as a variable. The functionality is good

2020-10-25 1/2



though, note that | haven't run the tests as I'm out of battery :-/

2011-05-29 03:11 pm - Felix Schéafer
OK, I've updated the branch linked to in my previous note, I've improved the option passing for the partials, | haven't touched the @:replace@ situation
though.

The tests are adapted to the new functionality of the controller, I've thrown one out of the window though, because it was testing if @#watch@ responds
to @GET@ requests (which it didn't before because of a @verify :method@ controller), this should be solved by removing the catch-all route though
rather than verifying it in the controller.

2011-05-29 06:26 pm - Eric Davis
| have code that adds multiple watchers, based on the one used at Admin > Groups > Add Users. | want to make sure we don't change the current code
so it can't be applied. Being able to search for and add several watchers at once is a huge Ul improvement.

| propose we hold off on this until after 2.0.0-RC1 is out. Then we can add my code and this fix as part of the [[BugMash]].

2011-05-29 06:26 pm - Eric Davis
- Target version deleted (2.0.0)

2011-05-30 08:05 am - Felix Schafer

Eric Davis wrote:

> | have code that adds multiple watchers, based on the one used at Admin > Groups > Add Users. | want to make sure we don't change the current
code so it can't be applied. Being able to search for and add several watchers at once is a huge Ul improvement.

You'll understand that | can't factor in something | haven't seen code for yet, and | don't think we should hold back patches solely because someone
has other code "lying around" for it (I agree that a multi-select would be useful, but that's currently not my point). | even seem to remember that was one
of the gripes we had in Redmine, | hope we can avoid this situation (or too many of them) here.

Anyway, from an (http) interface point of view, this only changes the creation of a new watcher from @POST
/watchers/new@/@WatchersController#new@ to @POST /watchers@/@WatchersController#create@, | haven't changed the passed parameters after
all because my proposed solution would have been "wrong" too, and the deletion of watchers has been changed from @POST
/watchers/destroy@/@WatchersController#destroy@ to @DELETE /watchers/:id@/@WatchersController#destroy@, the passed parameters have
changed accordingly. Both actions now also get passed the @replace@ parameter similar to @POST /watchers/watch@ and @POST

/watchers/unwatch@ (which are also wrong and should be refactored to use create and destroy, but that's another story).

2011-05-30 05:36 pm - Eric Davis

Felix SchA=fer wrote:

> You'll understand that | can't factor in something | haven't seen code for yet, and | don't think we should hold back patches solely because someone
has other code "lying around" for it (I agree that a multi-select would be useful, but that's currently not my point). | even seem to remember that was one
of the gripes we had in Redmine, | hope we can avoid this situation (or too many of them) here.

| understand. | think | found the "branch":https://github.com/edavis10/redmine_for_clients/commits/LSS-4892-wiki-bulk-watch and specific

"commit":https://github.com/edavis10/redmine_for_clients/commit/a7ed9d52c2a6e3a43da8a5995e80765¢c50d9ca50. From what it looks like | replaced

the @params[:user_id]@ with @params[:user_ids]@ anyways, so | don't think there will be a problem.
